# Abandon Ship script by Defiant <mail@defiant.homedns.org>
#
# Lisence: GPL - see README

# Settings:
# ----------

# How much Pods for Radius = 1
PodsPerSize = 4


# Please do not edit below this line - except you know what you are doing
# ================================================================================


# Import all that stuff we need
import App 
import MissionLib 
import Bridge.BridgeUtils 
import Lib.Ambiguity 
import QuickBattle.QuickBattle
import Custom.QuickBattleGame.QuickBattle
import loadspacehelper
import math

# Vars for the Button
pBridge = App.g_kSetManager.GetSet('bridge') 
BridgeType = App.BridgeSet_Cast(pBridge).GetConfig() 
g_pSaffi = App.CharacterClass_GetObject(pBridge, "XO") 
pSaffiMenu = Bridge.BridgeUtils.GetBridgeMenu("XO") 
ET_ABANDON_SHIP = App.Mission_GetNextEventType() 
ET_KILL_REMOTE_SHIP = App.Mission_GetNextEventType() 
AS_TIMER1 = App.Mission_GetNextEventType()
AS_END_SCENE_TIMER = App.Mission_GetNextEventType()
pPlayerOld = None
RemoteShipKillButtonExists = 0
pKillHostButton = None

# lets create the Button now
if (g_pSaffi != None): 
   event = Lib.Ambiguity.getEvent(ET_ABANDON_SHIP) 
   g_pSaffi.AddPythonFuncHandlerForInstance(event, __name__ + ".AbandonShip") 
   pButton = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString("Abandon Ship"), event, 0, g_pSaffi) 
   pSaffiMenu.PrependChild(pButton) 

App.TopWindow_GetTopWindow().AddPythonFuncHandlerForInstance(AS_TIMER1, __name__ + ".StartAbandonShip")
App.TopWindow_GetTopWindow().AddPythonFuncHandlerForInstance(AS_END_SCENE_TIMER, __name__ + ".AS_End_Cutscene")


# Red Alert, Abandon Ship now! -what todo:
def AbandonShip(pObject, pEvent): 
	#print("Abandon Ship")
	pShip = App.Game_GetCurrentPlayer()
	
	if ( pShip.GetHull().GetRadius() < 0.5 ):
		print("This Ship is to small - nothing to Abandon")
		return
	
	# First stop the Ship
	#import AI.Player.Stay
	#MissionLib.SetPlayerAI("Helm", AI.Player.Stay.CreateAI(pShip))
		
	# Play the sound
	pSound = App.TGSound_Create("sfx/Interface/new_game.wav", "AS_Sound", 0)
	pSound.SetSFX(0)
	pSound.SetInterface(1)
	App.g_kSoundManager.PlaySound("AS_Sound")

	# Start the Cutscene
	pSequence = App.TGSequence_Create ()

	pAction = App.TGScriptAction_Create("MissionLib", "StartCutscene")
	pSequence.AppendAction (pAction)

	pAction = App.TGScriptAction_Create("Actions.CameraScriptActions", "StartCinematicMode", 0)
	pSequence.AppendAction(pAction)	# Start cinematic mode first

	pAction	= App.TGScriptAction_Create("Actions.CameraScriptActions", "CutsceneCameraBegin", pShip.GetContainingSet().GetName ())
	pSequence.AppendAction(pAction)

	pAction = App.TGScriptAction_Create("Actions.CameraScriptActions", "DropAndWatch", pShip.GetContainingSet().GetName(), pShip.GetName ())
	pSequence.AppendAction(pAction)

	pSequence.Play()
	
	AbandonShipTimer(2, AS_TIMER1)


def StartAbandonShip(pObject, pEvent):
	global pPlayerOld, PodsPerSize
	
	# Some things we need
	pGame = App.Game_GetCurrentGame()
	pPlayer = pGame.GetPlayer()
	pSet = pPlayer.GetContainingSet()
	pShip = App.Game_GetCurrentPlayer()
	pMission = MissionLib.GetMission()
	pFriendlies = pMission.GetFriendlyGroup()
	sSetName = pSet.GetName()
	pPlayerOld = pPlayer
	itemp = None
	
	if (pShip.GetHull() == None):
		print("What? This Ship has no Hull? argh!")
		return
	
	# Creater Hull-Radius * 4 Escape Pods
	ShipSize = pShip.GetHull().GetRadius()
	CreateShipsNum = round(ShipSize, 0) * PodsPerSize
	#print(CreateShipsNum)
	
	# Choosing an Escape Pod for the Bridge Crew
	AS_BridgePod = round(App.g_kSystemWrapper.GetRandomNumber(CreateShipsNum), 0)
	if ( AS_BridgePod == 0 ):
		AS_BridgePod = 1
	#print("Bridge Pod is", AS_BridgePod)

	# Get the Players Location
	PlayerXpos = pShip.GetWorldLocation().GetX()
	PlayerYpos = pShip.GetWorldLocation().GetY()
	PlayerZpos = pShip.GetWorldLocation().GetZ()
	
	i = 1
	PodPosxyz = 1
	while (i <= CreateShipsNum):
		# Name of the Pod
		PodName = "Escape Pod " + str(i)
		# test if a Pod with this name already exists
		k = 10
		while ( MissionLib.GetShip(PodName) != None):
			# If its exists try another name (10+)
			itemp = i + k
			PodName = "Escape Pod " + str(itemp)
			k = 2*k
		#print("PodName is ", PodName)
		if itemp:
			i = itemp
			AS_BridgePod = i
		
		# Position Name of the Pod
		PodLaunchPoint = "PodLaunchPoint" + str(i)
		# Distance of Pods
		PodDistance = ShipSize
		# if PodDistance < 1 then the Game crashes, so fix
		if ( PodDistance < 1 ):
			PodDistance = 1

		# Create the Pod
		AS_EscapePod = loadspacehelper.CreateShip("EscapePod", pSet, PodName, PodLaunchPoint)

		# Disable Collisions
		AS_EscapePod.EnableCollisionsWith(pShip, 0)
		AS_EscapePod.DisableCollisionDamage(1)
		i2 = i
		while (i2 >= 1):
			if (i == 1):
				break
			AS_EscapePod.EnableCollisionsWith(MissionLib.GetShip("Escape Pod " + str(i2)), 0)
			i2 = i2 - 1
		
		# Random Numbers for Positions the Pods around the Ship
		PodCoord1 = App.g_kSystemWrapper.GetRandomNumber(PodDistance)

		# Position of the Pod
		kLocation = App.TGPoint3()

		# y =Wurzel(-x^2+2ax-a^2+r^2)+b
		if ( PodPosxyz == 1 ):
			A = PlayerXpos
			B = PlayerYpos
			X = PlayerXpos + PodCoord1
			R = PodDistance
			Y = -1 * math.sqrt(-X*X+2*A*X-A*A+R*R) + B
			Z = PlayerZpos + PodDistance
	
			kLocation.SetXYZ(X, Y, Z)
		elif ( PodPosxyz == 2 ):
			A = PlayerXpos
			B = PlayerZpos
			X = PlayerXpos + PodCoord1
			R = PodDistance
			Y = PlayerYpos + PodDistance
			Z = math.sqrt(-X*X+2*A*X-A*A+R*R) + B

			kLocation.SetXYZ(X, Y, Z)
		elif ( PodPosxyz == 3 ):
			A = PlayerXpos
			B = PlayerYpos
			R = PodDistance
			Y = PlayerYpos + PodCoord1
			X = -1 * math.sqrt(-Y*Y+2*B*Y-B*B+R*R) + A
			Z = PlayerZpos + PodDistance
	
			kLocation.SetXYZ(X, Y, Z)		
		elif ( PodPosxyz == 4 ):
			A = PlayerXpos
			B = PlayerZpos
			R = PodDistance
			Z = PlayerZpos + PodCoord1
			X = math.sqrt(-Z*Z+2*B*Z-B*B+R*R) + A
			Y = PlayerYpos + PodDistance
			
			kLocation.SetXYZ(X, Y, Z)
		elif ( PodPosxyz == 5 ):
			A = PlayerXpos
			B = PlayerZpos
			X = PlayerXpos + PodCoord1
			R = PodDistance
			Y = PlayerYpos + PodDistance
			Z = -1 * math.sqrt(-X*X+2*A*X-A*A+R*R) + B

			kLocation.SetXYZ(X, Y, Z)
		elif ( PodPosxyz == 6 ):
			A = PlayerXpos
			B = PlayerZpos
			R = PodDistance
			Z = PlayerZpos + PodCoord1
			X = -1 * math.sqrt(-Z*Z+2*B*Z-B*B+R*R) + A
			Y = PlayerYpos + PodDistance
			
			kLocation.SetXYZ(X, Y, Z)

		if ( pSet.IsLocationEmptyTG(kLocation, AS_EscapePod.GetRadius()*2, 1) == 0):
			print("Correcting Position for " + PodName)
			A = PlayerXpos
			B = PlayerYpos
			X = PlayerXpos + PodCoord1
			R = PodDistance
			Y = math.sqrt(-X*X+2*A*X-A*A+R*R) + B
			Z = PlayerZpos + PodDistance
	
			kLocation.SetXYZ(X, Y, Z)
			
			if ( pSet.IsLocationEmptyTG(kLocation, AS_EscapePod.GetRadius()*2, 1) == 0):
				print("Correcting Position for " + PodName + " (2)")
				A = PlayerXpos
				B = PlayerYpos
				R = PodDistance
				Y = PlayerYpos + PodCoord1
				X = math.sqrt(-Y*Y+2*B*Y-B*B+R*R) + A
				Z = PlayerZpos + PodDistance
	
				kLocation.SetXYZ(X, Y, Z)		

		if ( pSet.IsLocationEmptyTG(kLocation, AS_EscapePod.GetRadius()*2, 1) == 0):
			print("Unable to correct Position for " + PodName + " - bad Pilot on board!")
		# else do not re-enable Collision?
		
		#Now Position them
		AS_EscapePod.SetTranslate(kLocation)
		AS_EscapePod.UpdateNodeOnly()

		# To Friendly Group
		pFriendlies.AddName(PodName)
		
		# If this is our Pod: welcome on Board
		if ( AS_BridgePod == i ):
			#print("Welcome on Board of " + PodName + ", captain")
			pGame.SetPlayer(AS_EscapePod)
			# Players Escape Pod is Invincible.
			AS_EscapePod.SetInvincible(1)
			AS_EscapePod.GetSensorSubsystem().SetInvincible(1)
			AS_EscapePod.GetImpulseEngineSubsystem().SetInvincible(1)
			pPlayer = pGame.GetPlayer()
		else:
			# else set AI
			# We need to know if we are playing normal QB or QBR:
			# QB
			if QuickBattle.QuickBattle.pFriendlies:
				AIModule = __import__("QuickBattle.QuickBattleFriendlyAI")
				AS_EscapePod.SetAI(AIModule.CreateAI(AS_EscapePod))
			# QBR
			elif Custom.QuickBattleGame.QuickBattle.pFriendlies:
				AIModule = __import__("Custom.QuickBattleGame.QuickBattleFriendlyAI")
				AS_EscapePod.SetAI(AIModule.CreateAI(AS_EscapePod, 3, 0))
		
		# re-enable Collisions
		AS_EscapePod.DisableCollisionDamage(0)
		AS_EscapePod.EnableCollisionsWith(pShip, 1)

		# i++
		i = i + 1
		if ( PodPosxyz != 6 ):
			PodPosxyz = PodPosxyz + 1
		else:
			PodPosxyz = 1

		# End While loop here
		
	AbandonShipTimer(2, AS_END_SCENE_TIMER)


def AS_End_Cutscene(pObject, pEvent):
	global pPlayerOld

	pShip = App.Game_GetCurrentPlayer()

	# End the Cutscene
	pSequence = App.TGSequence_Create ()

	pAction = App.TGScriptAction_Create("Actions.CameraScriptActions", "CutsceneCameraEnd", pShip.GetContainingSet().GetName ())
	pSequence.AppendAction(pAction)

	pAction = App.TGScriptAction_Create("Actions.CameraScriptActions", "StopCinematicMode")
	pSequence.AppendAction(pAction)
	
	pAction = App.TGScriptAction_Create("MissionLib", "SetTarget", pPlayerOld.GetName())
	pSequence.AppendAction(pAction)
		
	pAction = App.TGScriptAction_Create("Actions.CameraScriptActions", "ChangeRenderedSet", "bridge")
	pSequence.AppendAction(pAction, 2) # Small 2 seconds Delay

	pAction = App.TGScriptAction_Create("MissionLib", "EndCutscene")
	pSequence.AppendAction(pAction)
	
	pSequence.Play()
	
	# clear
	App.g_kSoundManager.DeleteSound("AS_Sound")
	
	ActivateRemoteShipKill()
	#print("Abandon Ship is done - cu")


def AbandonShipTimer(iCountdown, iAction):
		# Create an event - it's a thing that will call this function
		pTimerEvent = App.TGEvent_Create()
		pTimerEvent.SetEventType(iAction)
		pTimerEvent.SetDestination(App.TopWindow_GetTopWindow())
					
		# Create a timer - it's a thing that will wait for a given time,then do something
		pTimer = App.TGTimer_Create()
		pTimer.SetTimerStart(App.g_kUtopiaModule.GetGameTime() + iCountdown)
		pTimer.SetDelay(0)
		pTimer.SetDuration(0)
		pTimer.SetEvent(pTimerEvent)
		App.g_kTimerManager.AddTimer(pTimer)


def ActivateRemoteShipKill():
	global g_pSaffi, pSaffiMenu, RemoteShipKillButtonExists, pKillHostButton
	
	if ( RemoteShipKillButtonExists == 1 ):
		pKillHostButton.SetEnabled()
		return

	if (g_pSaffi != None): 
		event = Lib.Ambiguity.getEvent(ET_KILL_REMOTE_SHIP) 
		g_pSaffi.AddPythonFuncHandlerForInstance(event, __name__ + ".KillHostShip") 
		pKillHostButton = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString("Destroy Host Ship"), event, 0, g_pSaffi) 
		pSaffiMenu.PrependChild(pKillHostButton)
		RemoteShipKillButtonExists = 1


def KillHostShip(pObject, pEvent):
	global pPlayerOld, pKillHostButton
	
	if pPlayerOld:
		if not pPlayerOld.IsDead():
			pPlayerOld.DestroySystem(pPlayerOld.GetHull())

		pKillHostButton.SetDisabled()
